;;; -*- Mode: LISP; Syntax: COMMON-LISP; Package: NEW-SESSION; Base: 10 -*-

(in-package :new-session)

(defmacro with-html (&body body)
  `(with-html-output-to-string (*standard-output* nil :prologue t)
     ,@body))

(defun application1-start-session ()
  (start-session "/application1/"))

(defun application2-start-session ()
  (start-session "/application2/"))

(defun index ()
  (with-html
      (:html
       (:head (:title "Index page"))
       (:body
	(:p
	 (:a :href "application1/index.html" :target "app1" "Application 1"))
	(:p
	 (:a :href "application2/index.html" :target "app2" "Application 2"))))))

(defun index-application1 ()
  (unless *session*
    (setf *session* (application1-start-session)
	  (session-value :rnd-number *session*) (random 10000)))    
  (with-html
      (:html
       (:head (:title "Index page application 1"))
       (:body
	(:p
	 (:a :href "random.html" "See random number boud to session"))))))

(defun index-application2 ()
  (unless *session*
    (setf *session* (application2-start-session)
	  (session-value :rnd-number *session*) (random 10000)))    
  (with-html
      (:html
       (:head (:title "Index page application 2"))
       (:body
	(:p
	 (:a :href "random.html" "See random number boud to session"))))))

(defun random-page ()
  (with-html
    (:html
     (:head (:title "Random page for realm"))
     (:body
      (:h1 (format *standard-output* "random number: ~a" (session-value :rnd-number)))
      (:p
       (:a :href "index.html" "back"))))))


(setq *dispatch-table*
      (nconc
       (list
	(create-prefix-dispatcher "/new-session/index.html" #'index)
	(create-prefix-dispatcher "/new-session/application1/index.html" #'index-application1 "app1")
	(create-prefix-dispatcher "/new-session/application1/random.html" #'random-page "app1")
	(create-prefix-dispatcher "/new-session/application2/index.html" #'index-application2 "app2")
	(create-prefix-dispatcher "/new-session/application2/random.html" #'random-page "app2"))
       (list #'default-dispatcher)))

(defvar *test-server* nil)

(defun start-test(&optional (port 4242))
  (setf *test-server* (start-server :port port)))

(defun stop-test ()
  (setf *test-server* (stop-server *test-server*)))